#ifndef __FIFO_H__
#define __FIFO_H__

#define FIFO_MAX_MESSAGES   16

//FIFO_Message FIFO_Messages[FIFO_MAX_MESSAGES];
extern int FIFO_LastMessageSent;

enum FIFO_Command
{
    MESSAGE_PLAY_SOUND = 1,
    MESSAGE_SOUND_ENDED,
    MESSAGE_MIC_TURNON,
    MESSAGE_MIC_TURNOFF,
    MESSAGE_MIC_MADESOUND,
    MESSAGE_WIFI_INIT,
    MESSAGE_WIFI_SYNC,
};

struct FIFO_Message
{
    FIFO_Command command;
    const void* data;
    u32 len;
    u32 rate;
    u8 vol;
    u8 pan;
    u8 format;
    u8 channel;
};

#if PROC_ARM9
#define FIFO_MessageArray ((FIFO_Message*)((uint32)(IPC)+sizeof(TransferRegion)))
#elif PROC_ARM7
#define FIFO_MessageArray ((FIFO_Message*)((uint32)(IPC)+sizeof(TransferRegion)+sizeof(FIFO_Message)*FIFO_MAX_MESSAGES))
#endif

void ARM9FIFO_Setup();
void ARM9FIFO_Handler();

void ARM7FIFO_Setup();
void ARM7FIFO_Handler();

FIFO_Message* FIFO_GetMessageContainer();
void FIFO_SendMessage(FIFO_Message* command);

#endif //__FIFO_H__
