#include "MySystem.h"

#include "BombGraphics.h"

#include "../art/Worker2.pal"
#include "../art/Worker2.til"
#include "../art/Player.pal"
#include "../art/Player.til"
#include "../art/Player2.pal"
#include "../art/Player3.pal"
#include "../art/Player4.pal"
#include "../art/Player5.pal"
#include "../art/Player6.pal"
#include "../art/Player7.pal"
#include "../art/Player8.pal"
#include "../art/BreakableBlock.pal"
#include "../art/BreakableBlock.til"
#include "../art/BreakableBlock2.pal"
#include "../art/BreakableBlock2.til"
#include "../art/Block.pal"
#include "../art/Block.til"
#include "../art/Block2.pal"
#include "../art/Block2.til"
#include "../art/Block3.pal"
#include "../art/Block3.til"
#include "../art/Bomb.pal"
#include "../art/Bomb.til"
#include "../art/BombExplode.pal"
#include "../art/BombExplode.til"
#include "../art/BoxBurn.pal"
#include "../art/BoxBurn.til"
#include "../art/Flames.pal"
#include "../art/Flames.til"
#include "../art/Elevator.pal"
#include "../art/Elevator.til"
#include "../art/PowerUpBomb.pal"
#include "../art/PowerUpBomb.til"
#include "../art/PowerUpGas.pal"
#include "../art/PowerUpGas.til"
#include "../art/ElevatorHidersTop.pal"
#include "../art/ElevatorHidersTop.til"
#include "../art/ElevatorHidersBottom.pal"
#include "../art/ElevatorHidersBottom.til"

#include "../art/TopScreenBG.pal"
#include "../art/TopScreenBG.til"
#include "../art/TopScreenOverlay.pal"
#include "../art/TopScreenOverlay.til"
#include "../art/BottomScreenBG.pal"
#include "../art/BottomScreenBG.til"
#include "../art/BottomScreenOverlay.pal"
#include "../art/BottomScreenOverlay.til"

void LoadBombGuyGraphics()
{
#if SYSTEM_NDS
    u16* VRAM_BGBitmap = &BG_GFX[0x2000 * BG_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)BottomScreenBGBitmap, (uint32*)VRAM_BGBitmap, 256*192/4);
    DMA_32bitCopy(3, (uint32*)BottomScreenBGPalette, (uint32*)BG_PALETTE, 256/2);

    u16* VRAM_OverlayBitmap = &BG_GFX[0x2000 * OVERLAY_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)BottomScreenOverlayBitmap, (uint32*)VRAM_OverlayBitmap, 256*192/4);
    DMA_32bitCopy(3, (uint32*)BottomScreenOverlayPalette, (uint32*)BG_PALETTE+240/2, 16/2);

    u16* VRAM_BGBitmapSub = &BG_GFX_SUB[0x2000 * BG_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)TopScreenBGBitmap, (uint32*)VRAM_BGBitmapSub, 256*192/4);
    DMA_32bitCopy(3, (uint32*)TopScreenBGPalette, (uint32*)BG_PALETTE_SUB, 256/2);

    u16* VRAM_OverlayBitmapSub = &BG_GFX_SUB[0x2000 * OVERLAY_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)TopScreenOverlayBitmap, (uint32*)VRAM_OverlayBitmapSub, 256*192/4);
    DMA_32bitCopy(3, (uint32*)TopScreenOverlayPalette, (uint32*)BG_PALETTE_SUB+240/2, 16/2);

    LoadPalette(SPRITE_PALETTE,  32, (u16*)PlayerPalette, 16);
    LoadPalette(SPRITE_PALETTE,  48, (u16*)BreakableBlockPalette, 16);
    LoadPalette(SPRITE_PALETTE,  64, (u16*)BlockPalette, 16);
    LoadPalette(SPRITE_PALETTE,  80, (u16*)BombPalette, 16);
    LoadPalette(SPRITE_PALETTE,  96, (u16*)Block2Palette, 16);
    LoadPalette(SPRITE_PALETTE, 112, (u16*)Block3Palette, 16);
    LoadPalette(SPRITE_PALETTE, 128, (u16*)BombExplodePalette, 16);
    LoadPalette(SPRITE_PALETTE, 144, (u16*)BoxBurnPalette, 16);
    LoadPalette(SPRITE_PALETTE, 160, (u16*)FlamesPalette, 16);
    LoadPalette(SPRITE_PALETTE, 176, (u16*)ElevatorPalette, 16);
    LoadPalette(SPRITE_PALETTE, 192, (u16*)PowerUpBombPalette, 16);
    LoadPalette(SPRITE_PALETTE, 208, (u16*)PowerUpGasPalette, 16);
    LoadPalette(SPRITE_PALETTE, 224, (u16*)ElevatorHidersBottomPalette, 16);

    VRAM_F_CR = VRAM_ENABLE | VRAM_F_LCD;
    LoadPalette(VRAM_F     ,  32, (u16*)PlayerPalette, 16);
    LoadPalette(VRAM_F+ 256,  32, (u16*)Player2Palette, 16);
    LoadPalette(VRAM_F+ 512,  32, (u16*)Player3Palette, 16);
    LoadPalette(VRAM_F+ 768,  32, (u16*)Player4Palette, 16);
    LoadPalette(VRAM_F+1024,  32, (u16*)Player5Palette, 16);
    LoadPalette(VRAM_F+1280,  32, (u16*)Player6Palette, 16);
    LoadPalette(VRAM_F+1536,  32, (u16*)Player7Palette, 16);
    LoadPalette(VRAM_F+1792,  32, (u16*)Player8Palette, 16);
    VRAM_F_CR = VRAM_ENABLE | VRAM_F_OBJ_EXT_PALETTE;    //slots 0 and 1

    LoadPalette(SPRITE_PALETTE_SUB,  32, (u16*)PlayerPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB,  48, (u16*)BreakableBlock2Palette, 16);
    LoadPalette(SPRITE_PALETTE_SUB,  64, (u16*)BlockPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB,  80, (u16*)BombPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB,  96, (u16*)Block2Palette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 112, (u16*)Block3Palette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 128, (u16*)BombExplodePalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 144, (u16*)BoxBurnPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 160, (u16*)FlamesPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 176, (u16*)ElevatorPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 192, (u16*)PowerUpBombPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 208, (u16*)PowerUpGasPalette, 16);
    LoadPalette(SPRITE_PALETTE_SUB, 224, (u16*)ElevatorHidersTopPalette, 16);

    VRAM_I_CR = VRAM_ENABLE | VRAM_I_LCD;
    LoadPalette(VRAM_I     ,  32, (u16*)PlayerPalette, 16);
    LoadPalette(VRAM_I+ 256,  32, (u16*)Player2Palette, 16);
    LoadPalette(VRAM_I+ 512,  32, (u16*)Player3Palette, 16);
    LoadPalette(VRAM_I+ 768,  32, (u16*)Player4Palette, 16);
    LoadPalette(VRAM_I+1024,  32, (u16*)Player5Palette, 16);
    LoadPalette(VRAM_I+1280,  32, (u16*)Player6Palette, 16);
    LoadPalette(VRAM_I+1536,  32, (u16*)Player7Palette, 16);
    LoadPalette(VRAM_I+1792,  32, (u16*)Player8Palette, 16);
    VRAM_I_CR = VRAM_ENABLE | VRAM_I_SUB_SPRITE_EXT_PALETTE;    //slots 0 and 1

    BreakableBlockTI.PaletteNumber = BreakableBlockTI.PaletteOffset/16;
    BreakableBlock2TI.PaletteNumber = BreakableBlock2TI.PaletteOffset/16;
    BlockTI.PaletteNumber = BlockTI.PaletteOffset/16;
    Block2TI.PaletteNumber = Block2TI.PaletteOffset/16;
    Block3TI.PaletteNumber = Block3TI.PaletteOffset/16;
    BombTI.PaletteNumber = BombTI.PaletteOffset/16;
    BombExplodeTI.PaletteNumber = BombExplodeTI.PaletteOffset/16;
    BoxBurnTI.PaletteNumber = BoxBurnTI.PaletteOffset/16;
    FlamesTI.PaletteNumber = FlamesTI.PaletteOffset/16;
    ElevatorTI.PaletteNumber = ElevatorTI.PaletteOffset/16;
    PowerUpBombTI.PaletteNumber = PowerUpBombTI.PaletteOffset/16;
    PowerUpGasTI.PaletteNumber = PowerUpGasTI.PaletteOffset/16;
    ElevatorHidersBottomTI.PaletteNumber = ElevatorHidersBottomTI.PaletteOffset/16;
    ElevatorHidersTopTI.PaletteNumber = ElevatorHidersTopTI.PaletteOffset/16;

    static int OffsetTiles = 1;

    g_MainSprites.SetTileStepSize(64);
    g_MainSprites.ResetLoadedTiles();
    g_MainSprites.LoadTiles(SPRITE_GFX, &BreakableBlockTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &ElevatorHidersBottomTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &ElevatorHidersBottomTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &PlayerTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &BlockTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &Block2TI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &Block3TI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &BombTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &BombExplodeTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &BoxBurnTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &FlamesTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &ElevatorTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &PowerUpBombTI, OffsetTiles);
    g_MainSprites.LoadTiles(SPRITE_GFX, &PowerUpGasTI, OffsetTiles);

    g_SubSprites.SetTileStepSize(64);
    g_SubSprites.ResetLoadedTiles();
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &BreakableBlock2TI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &ElevatorHidersTopTI, OffsetTiles);
    OffsetTiles = 0;
    // already offset when copied to mainsprites.
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &PlayerTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &BlockTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &Block2TI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &Block3TI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &BombTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &BombExplodeTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &BoxBurnTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &FlamesTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &ElevatorTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &PowerUpBombTI, OffsetTiles);
    g_SubSprites.LoadTiles(SPRITE_GFX_SUB, &PowerUpGasTI, OffsetTiles);

#endif //SYSTEM_NDS
}

void InitGraphicModes()
{
#if SYSTEM_NDS
    powerON(POWER_ALL_2D);

    VRAM_A_CR = VRAM_ENABLE | VRAM_A_MAIN_SPRITE;
    VRAM_B_CR = VRAM_ENABLE | VRAM_B_MAIN_BG_0x6000000;
    VRAM_C_CR = VRAM_ENABLE | VRAM_C_SUB_BG_0x6200000;
    VRAM_D_CR = VRAM_ENABLE | VRAM_D_SUB_SPRITE;

    videoSetMode(
                 MODE_5_2D | 
                 DISPLAY_SPR_1D_LAYOUT | 
                 DISPLAY_SPR_1D_SIZE_64 |
                 DISPLAY_SPR_ACTIVE |
                 DISPLAY_BG0_ACTIVE |       // Font
                 DISPLAY_BG1_ACTIVE |       // Scoreboxes
                 DISPLAY_BG2_ACTIVE |       // 256x192 240color background
                 //DISPLAY_BG3_ACTIVE |       // 256x192 16color overlay
                 DISPLAY_SPR_EXT_PALETTE |
                 0 );

    // ugly hack to not show the overlays in dualis, since it seems to have a bug with transparency
    char name[20];
    int i;
    for(i=0; i<PersonalData->nameLen; i++)
        name[i] = PersonalData->name[i];
    name[i] = 0;
    if( strcmp(name, "G.W. Bush") )
        DISPLAY_CR |= DISPLAY_BG3_ACTIVE;

    BG0_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (FONT_SCREEN_BASE_BLOCK << SCREEN_SHIFT);
    BG1_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (SCOREBOX_SCREEN_BASE_BLOCK << SCREEN_SHIFT);

    BG2_CR = BG_BMP8_256x256 | BG_PRIORITY_3 | BG_BMP_BASE(BG_BASEBLOCK);
    BG2_XDX = 1 << 8;
    BG2_XDY = 0;
    BG2_YDX = 0;
    BG2_YDY = 1 << 8;
    BG2_CX = 0;
    BG2_CY = 0;

    BG3_CR = BG_BMP8_256x256 | BG_PRIORITY_0 | BG_BMP_BASE(OVERLAY_BASEBLOCK);
    BG3_XDX = 1 << 8;
    BG3_XDY = 0;
    BG3_YDX = 0;
    BG3_YDY = 1 << 8;
    BG3_CX = 0;
    BG3_CY = 0;

    BLEND_CR = BLEND_SRC_BG3 | BLEND_DST_BG2 | BLEND_DST_SPRITE | BLEND_ALPHA; // | 1<<4
    BLEND_AB = 16 | 16<<8;

    videoSetModeSub(
                    MODE_5_2D | 
                    DISPLAY_SPR_1D_LAYOUT | 
                    DISPLAY_SPR_1D_SIZE_64 |
                    DISPLAY_SPR_ACTIVE | 
                    DISPLAY_BG0_ACTIVE |    // Font
                    DISPLAY_BG1_ACTIVE |    // Scoreboxes
                    DISPLAY_BG2_ACTIVE |    // 256x192 240color background
                    //DISPLAY_BG3_ACTIVE |    // 256x192 16color overlay
                    DISPLAY_SPR_EXT_PALETTE |
                    0 );

    // ugly hack to not show the overlays in dualis, since it seems to have a bug with transparency
    if( strcmp(name, "G.W. Bush") )
        SUB_DISPLAY_CR |= DISPLAY_BG3_ACTIVE;

    SUB_BG0_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (FONT_SCREEN_BASE_BLOCK << SCREEN_SHIFT);
    SUB_BG1_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (SCOREBOX_SCREEN_BASE_BLOCK << SCREEN_SHIFT);

    SUB_BG2_CR = BG_BMP8_256x256 | BG_PRIORITY_3 | BG_BMP_BASE(BG_BASEBLOCK);
    SUB_BG2_XDX = 1 << 8;
    SUB_BG2_XDY = 0;
    SUB_BG2_YDX = 0;
    SUB_BG2_YDY = 1 << 8;
    SUB_BG2_CX = 0;
    SUB_BG2_CY = 0;

    SUB_BG3_CR = BG_BMP8_256x256 | BG_PRIORITY_0 | BG_BMP_BASE(OVERLAY_BASEBLOCK);
    SUB_BG3_XDX = 1 << 8;
    SUB_BG3_XDY = 0;
    SUB_BG3_YDX = 0;
    SUB_BG3_YDY = 1 << 8;
    SUB_BG3_CX = 0;
    SUB_BG3_CY = 0;

    SUB_BLEND_CR = BLEND_SRC_BG3 | BLEND_DST_BG2 | BLEND_DST_SPRITE | BLEND_ALPHA; // | 1<<4
    SUB_BLEND_AB = 16 | 16<<8;

#endif //SYSTEM_NDS
}
