#include "MySystem.h"

#include "BaseObject.h"
#include "BombGraphics.h"

BreakableBlockObject::BreakableBlockObject()
{
    m_Type = OBJECTTYPE_BreakableBlock;
    m_SwappedGraphics = 0;
    m_PowerUp = 0;
}

BreakableBlockObject::~BreakableBlockObject()
{
}

void BreakableBlockObject::Tick()
{
    int tx = (int)m_PosX / 16;
    int ty = (int)m_PosY / 16;

    int map = QueryMap((int)m_PosZ);
    //if(map == -1)
    //    return;

    if(m_Health < 0)
    {
        m_Health = -1;

        if(!m_SwappedGraphics)
        {
            PlaySoundOnNextAvailableChannel(GAMESOUND_BoxDeath);
            m_SwappedGraphics = 1;
            SetTileInfo(&BoxBurnTI, 0, 1);
            m_CurrentAnim = 0;
            m_Frame = 0;
            m_Delay = 0;
        }

        if(m_Frame == 6 && m_Delay >= m_AnimSpeed-1)
        {
            g_pGameBoard->ClearTile(0, map, tx, ty);
            if(m_PowerUp != 0)
                g_pObjectManager->AddPowerUp((int)m_PosX, (int)m_PosY, (int)m_PosZ, m_PowerUp);
            m_ToBeDeleted = 1;
        }
    }
}

void BreakableBlockObject::AddExtraSprites(int sortposy, int x, int y)
{
    // add the crate behind the flame for the first 2 frames on the crate explosion.
    if(m_Health < 0 && m_Frame < 2)
    {
        if(m_PosZ < LEVEL2_Z)
        {
            g_MainSprites.AddSprite(sortposy-1, &BreakableBlockTI, 0, x, y+16, 0, 0, 3, 0, 0);
        }
        else
        {
            g_SubSprites.AddSprite(sortposy-1, &BreakableBlockTI, 0, x, y+16, 0, 0, 3, 0, 0);
        }
    }
}
