#include "MySystem.h"

#include "BaseObject.h"
#include "BombGraphics.h"

ElevatorObject::ElevatorObject()
{
    m_Type = OBJECTTYPE_Elevator;
    m_OverrideSortPos = 0;
    m_TickToMove = -1;
    m_Moving = 0;
    m_Dir = 0;
    m_ElevatorNumber = 0;
}

ElevatorObject::~ElevatorObject()
{
}

void ElevatorObject::SetElevatorNumber(int number)
{
    m_ElevatorNumber = number;

    //if(number == 0 || number == 1)
    m_OverrideSortPos = (int)m_PosY - 32;
}

void ElevatorObject::Tick()
{
    if(!m_Moving && m_TickToMove == g_FrameCount)
    {
        m_Moving = 1;

        m_Dir = 0;
        if(m_PosZ == 0)
            m_Dir = 1 * ELEVATORSPEED;
        if(m_PosZ == LEVEL2_Z)
            m_Dir = -1 * ELEVATORSPEED;
    }

    if(m_Moving)
    {
        m_TickToMove = g_FrameCount;
        m_PosZ += m_Dir;

        if(m_PosZ < 0)
        {
            m_PosZ = 0;
            m_Moving = 0;
        }

        if(m_PosZ > LEVEL2_Z)
        {
            m_PosZ = LEVEL2_Z;
            m_Moving = 0;
        }
    }
}

void ElevatorObject::AddExtraSprites(int sortposy, int x, int y)
{
    int frame = m_ElevatorNumber;

    g_MainSprites.AddSprite(sortposy+1, &ElevatorHidersBottomTI, frame, x, (int)m_PosY+35, 0, 0, 3, 0, 0);
    g_SubSprites.AddSprite(sortposy+1, &ElevatorHidersTopTI, frame, x, (int)m_PosY+35, 0, 0, 3, 0, 0);
}

int ElevatorObject::IsElevatorReadyToMove()
{
    if(m_TickToMove < g_FrameCount - ELEVATORPAUSEAFTERMOVING)
        return 1;

    return 0;
}

void ElevatorObject::TouchElevator(int TickToMove)
{
    PlaySoundOnNextAvailableChannel(GAMESOUND_Elevator);

    // if the packet arrives late, roll with it, and move as soon as possible.
    if(TickToMove < g_FrameCount)
        TickToMove = g_FrameCount;

    // if the elevator is already moving, stop it so this packet can go.
    if(m_Moving)
    {
        m_Moving = 0;
        if(m_Dir < 0)
            m_PosZ = 0;
        else
            m_PosZ = LEVEL2_Z;
    }

    // set the elevator's tick to move.
    m_TickToMove = TickToMove;
}
