#include "MySystem.h"

#include "BaseObject.h"
#include "BombGraphics.h"

FlameObject::FlameObject()
{
    m_Type = OBJECTTYPE_Flame;
    m_Life = 0;
    m_Spawned = 0;
    m_ExplodeDelay = 0;
}

FlameObject::~FlameObject()
{
}

void FlameObject::Tick()
{
    int tx = (int)m_PosX / 16;
    int ty = (int)m_PosY / 16;

    m_ExplodeDelay++;

    if(m_Life > 1 && m_Spawned == 0 && m_ExplodeDelay > 5)
    {
        m_Spawned = 1;

        if(m_CurrentAnim == FlameANIM_Down)
            ty += 1;
        if(m_CurrentAnim == FlameANIM_Up)
            ty -= 1;
        if(m_CurrentAnim == FlameANIM_Right && m_FlipHorizontal == 0)
            tx += 1;
        if(m_CurrentAnim == FlameANIM_Right && m_FlipHorizontal == 1)
            tx -= 1;

        if(tx < 0 || tx > MAP_WIDTH-1 || ty < 0 || ty > MAP_HEIGHT-1)
        {
        }
        else
        {
            int map = QueryMap((int)m_PosZ);

            ObjectType type = g_pGameBoard->GetTileObjectType(map, tx, ty);
            if(type == OBJECTTYPE_BreakableBlock || type == OBJECTTYPE_Bomb || type == OBJECTTYPE_PowerUp)
            {
                int index = g_pGameBoard->GetTileIndex(map, tx, ty);
                BaseObject* obj = g_pObjectManager->GetObject(type, index);
                obj->AddHealth(-1001);
                g_pGameBoard->ClearTile(0, map, tx, ty);
            }
            else if(type != OBJECTTYPE_Block && type != OBJECTTYPE_Flame)
            {
                FlameObject* obj = (FlameObject*)g_pObjectManager->AddFlame(tx*16, ty*16, (int)m_PosZ);
                obj->SetLife(m_Life-1);
                obj->SetCurrentAnim(m_CurrentAnim);
                obj->SetFlipHorizontal(m_FlipHorizontal);
            }
        }
    }

    if(m_Frame == 5 + m_CurrentAnim*6 && m_Delay >= m_AnimSpeed-1)
    {
        int tx = (int)m_PosX / 16;
        int ty = (int)m_PosY / 16;

        g_pGameBoard->ClearTile(0, QueryMap((int)m_PosZ), tx, ty);

        m_ToBeDeleted = 1;
    }
}

void FlameObject::AddExtraSprites(int sortposy, int x, int y)
{
}
