#ifndef __OBJECTMANAGER_H__
#define __OBJECTMANAGER_H__

class ObjectManager
{
protected:
    BaseObject* m_Players[MAX_PLAYERS];
    BaseObject* m_Blocks[MAX_BLOCKS];
    BaseObject* m_BreakableBlocks[MAX_BLOCKS];
    BaseObject* m_Bombs[MAX_BLOCKS];
    BaseObject* m_Flames[MAX_BLOCKS];
    BaseObject* m_PowerUps[MAX_BLOCKS];
    BaseObject* m_Elevators[4];

public:
    ObjectManager();
    ~ObjectManager();

    void TickAllObjects();
    void UpdateObjectSprites();

    BaseObject* AddPlayer();
    BaseObject* AddBlock(int x, int y, int z);
    BaseObject* AddBreakableBlock(int x, int y, int z, int powerup);
    BaseObject* AddBomb(int x, int y, int z, int fake = 0);
    BaseObject* AddFlame(int x, int y, int z);
    BaseObject* AddElevator(int x, int y, int z);
    BaseObject* AddPowerUp(int x, int y, int z, int powertype);

    void RemoveObject(ObjectType type, int index);
    BaseObject* GetObject(ObjectType type, int index);
    void DeleteAllOfType(ObjectType type);
    void DeleteDeadObjects();

    int CountBombsByPlayer(int player);
};

#endif //__OBJECTMANAGER_H__
