#ifndef __PLAYEROBJECT_H__
#define __PLAYEROBJECT_H__

enum Directions
{
    OBJECTDIR_Up,
    OBJECTDIR_Down,
    OBJECTDIR_Left,
    OBJECTDIR_Right,
};

enum
{
    PLAYERANIM_CaughtFire,
    PLAYERANIM_Died,
    PLAYERANIM_Win,
    PLAYERANIM_Idle, // front
    PLAYERANIM_Walk,
    PLAYERANIM_RunOnFire,
    //PLAYERANIM_Idle, // side
    //PLAYERANIM_Walk,
    //PLAYERANIM_RunOnFire,
    //PLAYERANIM_Idle, // back
    //PLAYERANIM_Walk,
    //PLAYERANIM_RunOnFire,
};

class PlayerObject : public BaseObject
{
protected:
    int m_DirectionFaced;

    float m_WalkSpeed;
    int m_KeysHeld;
    int m_MovementLocked;

    int m_TimeToLive;

    u8 m_PlayerNum;

public:
    int m_Power;
    int m_NumBombs;
    int m_MachineNum;

    PlayerObject();
    virtual ~PlayerObject();

    void SetOnFire();
    virtual void Tick();

    void SetPlayerNum(u8 player) { m_PlayerNum = player; }
    u8 QueryPlayerNum() { return m_PlayerNum; }

    void SendMovePacket(int playernum);

    void SetKeysHeld(int keys);
    void ProcessKeys();
    int GetKeysHeld() { return m_KeysHeld; }

    virtual void MoveAbs(float x, float y);
    virtual void MoveRelative(float x, float y);

    int CheckIfObjectFits(int map, int x, int y);

    int QueryDirectionFaced();
};

#endif //__PLAYEROBJECT_H__
