#include "MySystem.h"

#include "BaseObject.h"
#include "BombGraphics.h"

PowerUpObject::PowerUpObject()
{
    m_Type = OBJECTTYPE_PowerUp;
    m_SwappedGraphics = 0;
    m_PowerType = POWERTYPE_Invalid;
}

PowerUpObject::~PowerUpObject()
{
}

void PowerUpObject::Tick()
{
    int tx = (int)m_PosX / 16;
    int ty = (int)m_PosY / 16;

    int map = QueryMap((int)m_PosZ);
    //if(map == -1)
    //    return;

    if(m_Health < 0)
    {
        m_Health = -1;

        if(!m_SwappedGraphics)
        {
            m_SwappedGraphics = 1;
            SetTileInfo(&BoxBurnTI, 0, 1);
            m_CurrentAnim = 0;
            m_Frame = 0;
            m_Delay = 0;
        }

        if(m_Frame == 6 && m_Delay >= m_AnimSpeed-1)
        {
            g_pGameBoard->ClearTile(0, map, tx, ty);
            m_ToBeDeleted = 1;
        }
    }
}
