#include "MySystem.h"

#include "../art/ScoreBox.map"
#include "../art/ScoreBox.pal"
#include "../art/ScoreBox.til"

#include "BombGraphics.h"
#include "ScoreBox.h"
#include "TextMap.h"

void SetupScoreBox()
{
#if SYSTEM_NDS
    LoadPalette(BG_PALETTE, 224, (u16*)ScoreBoxPalette, 16);
    DMA_32bitCopy(3, (uint32*)ScoreBoxTiles, (uint32*)BG_GFX+SCOREBOX_TILE_OFFSET*8, sizeof(ScoreBoxTiles));
    //BG0_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (SCOREBOX_SCREEN_BASE_BLOCK << SCREEN_SHIFT);

    LoadPalette(BG_PALETTE_SUB, 224, (u16*)ScoreBoxPalette, 16);
    DMA_32bitCopy(3, (uint32*)ScoreBoxTiles, (uint32*)BG_GFX_SUB+SCOREBOX_TILE_OFFSET*8, sizeof(ScoreBoxTiles));
#endif //SYSTEM_NDS
}

void ClearScoreBoxMap(u16* map)
{
    int x,y;
    u16* HWMap;
    
    HWMap = (uint16*)SCREEN_BASE_BLOCK(SCOREBOX_SCREEN_BASE_BLOCK);
    if(map != NULL)
        HWMap = map;

    for(y=0; y<24; y++)
        for(x=0; x<32; x++)
            HWMap[y*32+x] = FONT_TILE_BLANK;

    HWMap = (uint16*)SCREEN_BASE_BLOCK_SUB(SCOREBOX_SCREEN_BASE_BLOCK);
    if(map != NULL)
        HWMap = map;

    for(y=0; y<24; y++)
        for(x=0; x<32; x++)
            HWMap[y*32+x] = FONT_TILE_BLANK;

    ClearTextMap(NULL);
}

void ShowScoreBox()
{
    int i, screen;
    int x,y;
    u16* HWMap;

    for(i=0; i<MAX_PLAYERS; i++)
    {
        if(g_pPlayers[i] == NULL)
            continue;

        int scr, offx, offy;

        int mac = g_pPlayers[i]->m_MachineNum+1;

        if(mac < 0 || mac >= MAX_PLAYERS)
            continue;

        int pos = mac;
        scr = 1;
        if(pos > 3)
        {
            scr = 0;
            pos -= 4;
        }

        if(pos==0)
        {
            offx = 3;
            offy = 5;
        }
        else if(pos==1)
        {
            offx = 17;
            offy = 13;
        }
        else if(pos==2)
        {
            offx = 3;
            offy = 13;
        }
        else
        {
            offx = 17;
            offy = 5;
        }

        sprintf(temptext, "%s", g_PlayerName[mac]);
        int len = (int)strlen(g_PlayerName[mac]);
        int lenoff = (10-len)/2;
        DrawTextToMap(scr, NULL, offx+1+lenoff, offy+1, 1, temptext);

        sprintf(temptext, "Wins: %2d", g_PlayerWins[mac]);
        DrawTextToMap(scr, NULL, offx+2, offy+3, 1, temptext);
    }

    for(screen = 0; screen < 2; screen++)
    {
        if(screen == 0)
            HWMap = (uint16*)SCREEN_BASE_BLOCK(SCOREBOX_SCREEN_BASE_BLOCK);
        else
            HWMap = (uint16*)SCREEN_BASE_BLOCK_SUB(SCOREBOX_SCREEN_BASE_BLOCK);

        for(i=0; i<4; i++)
        {
            int offx, offy;
            if(i==0)
            {
                offx = 3;
                offy = 5;
            }
            else if(i==1)
            {
                offx = 17;
                offy = 5;
            }
            else if(i==2)
            {
                offx = 3;
                offy = 13;
            }
            else
            {
                offx = 17;
                offy = 13;
            }

            for(y=offy; y<offy+6; y++)
            {
                for(x=offx; x<offx+12; x++)
                {
                    HWMap[y*32+x] = ScoreBoxMap[(y-offy)*12+(x-offx)] + SCOREBOX_TILE_OFFSET | (224/16)<<12;
                }
            }
        }
    }
}
