#include "MySystem.h"

#include "GameSounds.h"
#include "TextMap.h"

#if SYSTEM_NDS
#include "Music_raw.h"
#include "BombDrop_raw.h"
#include "BoxDeath_raw.h"
#include "Death01_raw.h"
#include "Death02_raw.h"
#include "Elevator_raw.h"
#include "Explosion_raw.h"
#include "ExtraBomb_raw.h"
#include "ExtraBomb_alt_raw.h"
#include "ExtraGas_raw.h"
#endif //SYSTEM_NDS

//SoundObject* SoundObjects[50];

extern int MIC_MadeNoise;

#if SYSTEM_NDS
void HandleFIFOMessage(FIFO_Message* message)
{
    if(message == 0)
        return;
    
    switch(message->command)
    {
    case MESSAGE_SOUND_ENDED:
        HandleSoundMessage(message);
        break;

    case MESSAGE_MIC_MADESOUND:
        HandleMicSound(message);
        break;

    case MESSAGE_WIFI_SYNC:
        Wifi_Sync();
        break;

    default:
        break;
    }
}

void HandleMicSound(FIFO_Message* message)
{
    //MIC_MadeNoise = 1;
    ////PlaySound(Music_raw, Music_raw_size, 11025, FORMAT_ADPCM, 127, 64, 0);

    ////extern uint16 mapSub0Copy[32*24];

    ////static int line = 0;
    ////char buf[10];
    ////sprintf(buf, "%03d", message->rate);
    ////DrawTextToMap(NULL, 0, line, 2, buf);
    ////if(mapSub0Copy)
    ////    DrawTextToMap(&mapSub0Copy[0], 0, line, 2, buf);
    ////line++;
    ////line = line%10;
}
#endif //SYSTEM_NDS

int ChannelsPlaying[16];
int PlayedThisFrame[GAMESOUND_MAX];
int PlayedAnySoundThisFrame;

void ClearSoundsPlayedThisFrame()
{
    int i;
    for(i=0; i<GAMESOUND_MAX; i++)
        PlayedThisFrame[i] = 0;
    PlayedAnySoundThisFrame = 0;
}

void MarkAllChannelsClear()
{
    int i;

    for(i=0; i<16; i++)
    {
        ChannelsPlaying[i] = 0;
    }
}

void PlaySoundOnNextAvailableChannel(GAMESOUNDS sound)
{
    //int i;
    int freq = 44100;
    int channel = 16;

    //// only play death screams on channel 2 and 3.
    //if(sound == GAMESOUND_Death01) // || sound == Death02)
    //{
    //    if(ChannelsPlaying[2] == 0)
    //    {
    //        sound = GAMESOUND_Death01;
    //        channel = 2;
    //    }
    //    else if(ChannelsPlaying[3] == 0)
    //    {
    //        sound = GAMESOUND_Death02;
    //        channel = 3;
    //    }
    //}
    //else
    //{
    //    for(i=4; i<16; i++)
    //    {
    //        if(ChannelsPlaying[i] == 0)
    //            break;
    //    }

    //    channel = i;
    //}

    //// too many sounds playing.
    //if(channel >= 16)
    //    return;

    // I have no time to figure out why sound cuts out...
    // so I'll try reducing how much can get played.
    if(PlayedAnySoundThisFrame)
        return;

    PlayedAnySoundThisFrame = 1;

    //ChannelsPlaying[channel] = 1;
    if( PlayedThisFrame[sound] )
        return;

    PlayedThisFrame[sound] = 1;

#if SYSTEM_NDS
    if(sound == GAMESOUND_BombDrop)
        PlaySound(BombDrop_raw, BombDrop_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_BoxDeath)
        PlaySound(BoxDeath_raw, BoxDeath_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_Death01)
        PlaySound(Death01_raw, Death01_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_Death02)
        PlaySound(Death02_raw, Death02_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_Elevator)
        PlaySound(Elevator_raw, Elevator_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_Explosion)
        PlaySound(Explosion_raw, Explosion_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_ExtraBomb)
        PlaySound(ExtraBomb_raw, ExtraBomb_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_ExtraBomb_alt)
        PlaySound(ExtraBomb_alt_raw, ExtraBomb_alt_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
    if(sound == GAMESOUND_ExtraGas)
        PlaySound(ExtraGas_raw, ExtraGas_raw_size, freq, FORMAT_ADPCM, 127, 64, channel);
#endif //SYSTEM_NDS
}

#if SYSTEM_NDS
void HandleSoundMessage(FIFO_Message* message)
{
    if(message->command != MESSAGE_SOUND_ENDED)
        return;

    extern int musicfreq;
    extern int musicvol;

    if(message->channel == 0)
        PlaySound(Music_raw, Music_raw_size, musicfreq, FORMAT_ADPCM, musicvol, 64, 0);
    //else if(message->channel == 1)
    //    PlaySound(Music_raw, Music_raw_size, musicfreq, FORMAT_ADPCM, musicvol, 127, 1);
    else
        ChannelsPlaying[message->channel] = 0;

    //char buf[10];
    //sprintf(buf, "%03d", message->channel);
    //DrawTextToMap(NULL, 1, 0, 2, buf);

    //if(message->channel == 1)
    //    PlaySound(Music_raw, Music_raw_size, 11025, FORMAT_ADPCM, 127, 127, 1);

    //int r = rand()%2;
    //if(r == 0)
    //    PlaySound(HitWood01_raw, HitWood01_raw_size);
    //else
    //    PlaySound(HitWood02_raw, HitWood02_raw_size);
}
#endif //SYSTEM_NDS

void PlaySound(const void* buffer, u32 length, int rate, int format, int vol, int pan, int channel)
{
#if SYSTEM_NDS
    FIFO_Message* message = FIFO_GetMessageContainer();

    if(message)
    {
        message->command = MESSAGE_PLAY_SOUND;
        message->channel = channel;
        message->data = buffer;
        message->len = length;
        message->rate = rate;
        message->vol = vol;
        message->pan = pan;
        message->format = FORMAT_ADPCM;

        FIFO_SendMessage(message);
    }
#endif //SYSTEM_NDS
}
