#ifndef __GAMESOUND_H__
#define __GAMESOUND_H__

#if SYSTEM_NDS

#include "FIFO.h"

void HandleFIFOMessage(FIFO_Message* message);

void HandleSoundMessage(FIFO_Message* message);
void HandleMicSound(FIFO_Message* message);

#endif //SYSTEM_NDS

#define MAX_SOUND_VARIATIONS    10

#define FORMAT_8BIT     0
#define FORMAT_16BIT    1
#define FORMAT_ADPCM    2
#define FORMAT_PSG      3

enum GAMESOUNDS
{
    GAMESOUND_BombDrop,     //done
    GAMESOUND_BoxDeath,     //done
    GAMESOUND_Death01,      //done
    GAMESOUND_Death02,      //done
    GAMESOUND_Elevator,     //done
    GAMESOUND_Explosion,    //done
    GAMESOUND_ExtraBomb,
    GAMESOUND_ExtraBomb_alt,
    GAMESOUND_ExtraGas,
    GAMESOUND_MAX,
};

void ClearSoundsPlayedThisFrame();

void MarkAllChannelsClear();
void PlaySoundOnNextAvailableChannel(GAMESOUNDS sound);

void PlaySound(const void* buffer, u32 length, int rate = 11025, int format = FORMAT_ADPCM, int vol = 127, int pan = 64, int channel = 99);

class SoundObject
{
public:
    u8 m_NumSounds; // max 10 for now

    u8* m_Sound[MAX_SOUND_VARIATIONS];
    u8* m_SoundEnd[MAX_SOUND_VARIATIONS];
    u32 m_SoundSize[MAX_SOUND_VARIATIONS];
    
    void PlaySound();
};

extern SoundObject* SoundObjects[50];

void SetupSounds();
void DestroySounds();

#endif //__GAMESOUND_H__
