#include "MySystem.h"

#include <malloc.h>

#include "BombMain.h"

#include "tileinfo.h"
#include "MyDMA.h"
#include "touch.h"
#include "TextMap.h"

#include "WifiMenu.h"
#include "Menu.h"
#include "GameSounds.h"

#include "../art/TitleBG.til"
#include "../art/TitleBG.pal"
#include "../art/MainMenuBG.til"
#include "../art/MainMenuBG.pal"
//#include "../art/WifiMenu.til"

// TODO: reenable music
#include "Music_raw.h"
//#include "HitWood01_raw.h"

GameOptionsStruct GameOptions;
SRAMSave g_SRAM;
int _RELEASE = 1;

int g_FrameCount = 0;
        
int TextColor = 15;

int musicfreq = 22050; //11025;
int musicvol = 64; //127;
//int musicfreq = 44100;

char temptext[200];

void SetMicLevel(int level)
{
#if SYSTEM_NDS
    FIFO_Message* message = FIFO_GetMessageContainer();
    if(message)
    {
        message->command = MESSAGE_MIC_TURNON;

        if(level == 0)
            message->command = MESSAGE_MIC_TURNOFF;
        if(level == 1)
            message->rate = 100;
        if(level == 2)
            message->rate = 50;
        if(level == 3)
            message->rate = 20;

        FIFO_SendMessage(message);
    }
#endif //SYSTEM_NDS
}

int main(void)
{
#define DEFAULT_TESTMAP_VALUE   0

    GameOptions.InitialSeed = 0;

    int randomseed = 0;
    srand(IPC->curtime[7] + IPC->curtime[6] + IPC->curtime[5]);

    g_SRAM.Init();

#if SYSTEM_NDS
    irqInit();

    ARM9FIFO_Setup();
#endif //SYSTEM_NDS

    //if(!_EMULATOR)
    //{
    //    u32 Wifi_pass = Wifi_Init(WIFIINIT_OPTION_USELED);
    //    FIFO_Message* message = FIFO_GetMessageContainer();
    //    if(message)
    //    {
    //        message->command = MESSAGE_WIFI_INIT;
    //        message->len = Wifi_pass;
    //        FIFO_SendMessage(message);
    //    }

    //    irqSet(IRQ_TIMER3, Timer_50ms); // setup timer IRQ
    //    irqEnable(IRQ_TIMER3);
    //    Wifi_SetSyncHandler(arm9_synctoarm7); // tell wifi lib to use our handler to notify arm7

    //    // set timer3
    //    *((volatile u16 *)0x0400010C) = -6553; // 6553.1 * 256 cycles = ~50ms;
    //    *((volatile u16 *)0x0400010E) = 0x00C2; // enable, irq, 1/256 clock

    //    while(Wifi_CheckInit() == 0) // wait for arm7 to be initted successfully
    //    {
    //        //swiWaitForVBlank();
    //        while(VCOUNT>192); // wait for vblank
    //        while(VCOUNT<192);
    //    }
    //}

    while(1)
    {
        MenuInitSystem();
#if SYSTEM_NDS
        videoSetModeSub(
                    MODE_5_2D | 
                    DISPLAY_BG0_ACTIVE |
                    //DISPLAY_BG2_ACTIVE |
                    0 );
#endif //SYSTEM_NDS

        //FIFO_Message* message = FIFO_GetMessageContainer();
        //if(message)
        //{
        //    message->command = MESSAGE_MIC_TURNON;
        //    FIFO_SendMessage(message);
        //}

        scanKeys();
#if SYSTEM_NDS
        swiWaitForVBlank();
        scanKeys();
        swiWaitForVBlank();
        scanKeys();
#endif //SYSTEM_NDS

        //SetupSounds();
        //playGenericSound(Music_raw, Music_raw_size);
        //audio_play_sound(HitWood01_raw, HitWood01_raw_size);
#if SYSTEM_NDS
        PlaySound(Music_raw, Music_raw_size, musicfreq, FORMAT_ADPCM, musicvol, 64, 0);
        //PlaySound(Music_raw, Music_raw_size, musicfreq, FORMAT_ADPCM, musicvol, 127, 1);
#endif //SYSTEM_NDS

        //=====================================================
        // setup the title screen on the main display
        //=====================================================
//#if SYSTEM_NDS
//        int x,y;
//
//        for(x = 0; x < SCREEN_WIDTH; x++)
//            for(y = 0; y < SCREEN_HEIGHT; y++)
//                BG_GFX[0x2000*2 + y*SCREEN_WIDTH + x] = TitleBGBitmap[y*SCREEN_WIDTH + x] | BIT(15);
//#endif //SYSTEM_NDS
        //uint16* Map0 = (uint16*)SCREEN_BASE_BLOCK(3);
        //BG0_CR = TEXTBG_SIZE_256x256 | BG_PRIORITY_3 | BG_COLOR_256 | (3 << SCREEN_SHIFT);

        //LoadPalette(BG_PALETTE, 0, (u16*)MenuBGPalette, 256);
        //DMA_32bitCopy(3, (uint32*)MenuBGTiles, (uint32*)BG_GFX, sizeof());

        //int x,y;
        //for(y=0; y<24; y++)
        //    for(x=0; x<32; x++)
        //        Map0[y*32+x] = MenuBGMap[y*32+x];

        SetupSubScreenFont();

        ClearTextMap(NULL);

        static int seentitle = 0;

        if(!seentitle)
        {
            seentitle = 1;
            while(1)
            {
                //DrawTextToMap(1, NULL, 0, 11, TextColor, "0123456789abcDEF");

                // title screen
                scanKeys();
                if(keysUp() & KEY_START || keysUp() & KEY_TOUCH || keysUp() & KEY_A)
                    break;
                randomseed = rand();

            }
            srand(randomseed);
        }

#if SYSTEM_NDS
        swiWaitForVBlank();
        lcdSwap();
#endif //SYSTEM_NDS

#if SYSTEM_NDS
        videoSetModeSub(
                    MODE_5_2D | 
                    DISPLAY_BG0_ACTIVE |
                    DISPLAY_BG2_ACTIVE |
                    0 );

#endif //SYSTEM_NDS

        int Credits;
        Credits = 0;


        int currentselected = 0;

        while(1)
        {
            // menu
            scanKeys();

            swiWaitForVBlank();

            // clear the screen
            ClearTextMap(NULL);

            if(Credits)
            {
                if(keysUp() & 0x1FFF) // any key up to the touchscreen(not the lid)
                    Credits = 0;

                DrawTextToMap(1, NULL, 13, 4, TextColor, "Credits");
                DrawTextToMap(1, NULL, 4, 21, TextColor, "   www.atouchofwar.com");

                int curline = 8;
                DrawTextToMap(1, NULL, 3, curline, TextColor, "  Code: Jimmy Lord");
                curline+=2;
                DrawTextToMap(1, NULL, 3, curline, TextColor, "   Art: Louis Dozois");
                curline+=2;
                DrawTextToMap(1, NULL, 3, curline, TextColor, " Music");
                curline++;
                DrawTextToMap(1, NULL, 1, curline, TextColor, " & Sound: Mike Keogh");
            }
            else
            {
                //if(keysUp() & KEY_START)
                //{
                //    WIFIMain();
                //    continue;
                //    //break;
                //}

                // hacked in sound test.
                MarkAllChannelsClear();
                static int currsound = (int)GAMESOUND_BombDrop;
                if(keysUp() & KEY_RIGHT)
                    currsound++;
                if(keysUp() & KEY_LEFT)
                    currsound--;
                if(currsound < 0)
                    currsound = 0;
                if(currsound >= (int)GAMESOUND_MAX)
                    currsound = (int)GAMESOUND_MAX-1;
                if(keysUp() & KEY_Y)
                    PlaySoundOnNextAvailableChannel((GAMESOUNDS)currsound);

                if( keysUp() & KEY_UP )
                    currentselected--;
                if( keysUp() & KEY_DOWN )
                    currentselected++;

                if(currentselected < 0)
                    currentselected = 0;
                if(currentselected > 2-1)
                    currentselected = 2-1;

                if(currentselected == 0)
                    DrawTextToMap(1, NULL, 8, 5, TextColor, "->");
                if(currentselected == 1)
                    DrawTextToMap(1, NULL, 8, 18, TextColor, "->");

                if(keysUp() & KEY_SELECT)
                {
                    Credits = 1;
                    continue;
                }

                //if(keysUp() & KEY_A)
                //{
                //    break;
                //}

                if(0)
                {
                    sprintf(temptext, "%d", TotalAllocatedRam);
                    DrawTextToMap(1, NULL, 0, 10, TextColor, temptext);
                    
#if SYSTEM_NDS
                    struct mallinfo info;
                    info = mallinfo();
                    sprintf(temptext, "%d", info.uordblks);
                    DrawTextToMap(1, NULL, 0, 11, TextColor, temptext);
#endif //SYSTEM_NDS
                }

                CPPListNode* node;
                for( node = AllocatedRam.HeadNode.Next; node->Next; node = node->Next )
                {
                    MemObject* obj = (MemObject*)node;
                    sprintf(DEBUG_String, "RAM: %d, %d, %d, %s", (int)obj->m_size, obj->m_type, (int)obj->m_line, &obj->m_file[strlen(obj->m_file)-15]);
                    //sprintf(DEBUG_String, "RAM: %s", obj->m_file);
                    DEBUG_Print();
                }

                DrawTextToMap(1, NULL, 11, 5, TextColor, "WIFI Start");
                DrawTextToMap(1, NULL, 12, 18, TextColor, "Practice");
                DrawTextToMap(1, NULL, 32-1, 0, TextColor, "C");

                if(!_RELEASE)
                {
                    DrawTextToMap(1, NULL, 13, 0, TextColor, "DEBUG");
                    DrawTextToMap(1, NULL, 0, 1, TextColor, "DEBUG");
                    DrawTextToMap(1, NULL, 0, 2, TextColor, "DEBUG");
                    DrawTextToMap(1, NULL, 0, 3, TextColor, "DEBUG");
                    DrawTextToMap(1, NULL, 0, 4, TextColor, "DEBUG");
                }

                static int TouchX;
                static int TouchY;

                if(keysUp() & KEY_A || keysUp() & KEY_START)
                {
                    if(currentselected == 0)
                    {
                        // clear the screen
                        ClearTextMap(NULL);
                        WIFIMain();
                        continue;
                    }
                    if(currentselected == 1)
                        break;
                }

                if(keysHeld() & KEY_TOUCH)
                {
                    static int FrameCount = 0;
                    FrameCount++;
                    GetTouchXY(FrameCount, &TouchX, &TouchY);
                }

                if(keysUp() & KEY_TOUCH)
                {
                    if(TouchY < 32 && TouchX > 256-32)
                    {
                        Credits = 1;
                        continue;
                    }

                    // start the wifi game.
                    if(TouchY < 16*8)
                    {
                        // clear the screen
                        ClearTextMap(NULL);
                        WIFIMain();
                        continue;
                    }

                    // start the game
                    if(TouchY > 16*8)
                        break;
                }


                randomseed = rand();
             }
        }

        srand(randomseed);

        GameOptions.InitialSeed = rand();
        BombMain();
    }
}

void MenuVblank()
{
    g_FrameCount++;
}

int MenuInitSystem(void)
{
#if SYSTEM_NDS
    powerON(POWER_ALL_2D);
    irqSet(IRQ_VBLANK, MenuVblank);
    irqEnable(IRQ_VBLANK);

    VRAM_A_CR = VRAM_ENABLE | VRAM_A_MAIN_SPRITE;
    VRAM_B_CR = VRAM_ENABLE | VRAM_B_MAIN_BG_0x6000000;
    VRAM_C_CR = VRAM_ENABLE | VRAM_C_SUB_BG_0x6200000;
    VRAM_D_CR = VRAM_ENABLE | VRAM_D_SUB_SPRITE;

    videoSetMode(
                 MODE_5_2D | 
                 DISPLAY_BG0_ACTIVE |
                 DISPLAY_BG2_ACTIVE |
                 0 );

#define MENUBG_BASEBLOCK    5

    BG2_CR = BG_BMP8_256x256 | BG_PRIORITY_3 | BG_BMP_BASE(MENUBG_BASEBLOCK);
    BG2_XDX = 1 << 8;
    BG2_XDY = 0;
    BG2_YDX = 0;
    BG2_YDY = 1 << 8;
    BG2_CX = 0;
    BG2_CY = 0;

    //set up the sub display
    videoSetModeSub(
                    MODE_5_2D | 
                    DISPLAY_BG0_ACTIVE |
                    DISPLAY_BG2_ACTIVE |
                    0 );

    SUB_BG2_CR = BG_BMP8_256x256 | BG_PRIORITY_3 | BG_BMP_BASE(MENUBG_BASEBLOCK);
    SUB_BG2_XDX = 1 << 8;
    SUB_BG2_XDY = 0;
    SUB_BG2_YDX = 0;
    SUB_BG2_YDY = 1 << 8;
    SUB_BG2_CX = 0;
    SUB_BG2_CY = 0;

    // copy the main menu screen and palette from 16-255;
    u16* VRAM_BGBitmap = &BG_GFX[0x2000 * MENUBG_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)TitleBGBitmap, (uint32*)VRAM_BGBitmap, 256*192/4);
    DMA_32bitCopy(3, (uint32*)TitleBGPalette, (uint32*)BG_PALETTE+16/2, 240/2);

    // copy the main menu screen and palette from 16-255;
    u16* VRAM_BGBitmapSub = &BG_GFX_SUB[0x2000 * MENUBG_BASEBLOCK];
    DMA_32bitCopy(3, (uint32*)MainMenuBGBitmap, (uint32*)VRAM_BGBitmapSub, 256*192/4);
    DMA_32bitCopy(3, (uint32*)MainMenuBGPalette, (uint32*)BG_PALETTE_SUB+16/2, 240/2);

#endif //SYSTEM_NDS
    return 0;
}
