#include "MySystem.h"

#include "ServerList.h"
#include "ServerSelect.h"

char ServerList[MAX_SERVERSTRING];
int SERVERLIST_NumServers;

char SERVERLIST_Names[MAX_SERVERS][20];
char SERVERLIST_Servers[MAX_SERVERS][16];
char SERVERLIST_LANIPs[MAX_SERVERS][16];

#define PORT 80

#if SYSTEM_NDS
#define SOCKET  int
#endif //SYSTEM_NDS

SOCKET httpsock;
hostent* hostinfo;

char serverstr[500];

void ParseServerList()
{
    int i;
    int len = (int)strlen(ServerList);
    SERVERLIST_NumServers = 0;
    int wp = 0;

    int phase = 0;
    for(i=0; i<len; i++)
    {
        if( ServerList[i] == ',' || ServerList[i] == '>' )
        {
            phase++;
            wp = 0;
        }

        if( phase == 0 )
        {
            if( ServerList[i] >= '0' && ServerList[i] <= 'z' )
            {
                SERVERLIST_Names[SERVERLIST_NumServers][wp] = ServerList[i];
                wp++;
            }
        }
        else if(phase == 1)
        {
            if( ServerList[i] == '.' || (ServerList[i] >= '0' && ServerList[i] <= '9') )
            {
                SERVERLIST_Servers[SERVERLIST_NumServers][wp] = ServerList[i];
                wp++;
            }
        }
        else if(phase == 2)
        {
            if( ServerList[i] == '.' || (ServerList[i] >= '0' && ServerList[i] <= '9') )
            {
                SERVERLIST_LANIPs[SERVERLIST_NumServers][wp] = ServerList[i];
                wp++;
            }
        }
        else //if(phase == 4)
        {
            phase = 0;
            wp = 0;
            SERVERLIST_NumServers++;
        }
    }
}

int SERVERLIST_Init()
{
    hostinfo = gethostbyname("www.atouchofwar.com");
    if(hostinfo == NULL)
        return 1; // error

    return 0;
}

int SERVERLIST_CheckForResults()
{
#define MAXDATASIZE 100
    char buffer[MAXDATASIZE];

    if(httpsock == 0)
        return SLRC_GenericError;

    int numbytes = recv(httpsock, buffer, MAXDATASIZE, 0);

    if(numbytes <= 0)
        return SLRC_Waiting;

    if(numbytes)
    {
        int errorcode = atoi( &buffer[strlen("HTTP/1.0 ")] );

        if(errorcode == 200) // all's good.
        {
            int textfound = 0;
            int pos=0;

            while(!textfound)
            {
                char lastfourchars[5] = "    ";
                lastfourchars[4] = 0;

                for(pos = 0; pos < numbytes; pos++)
                {
                    lastfourchars[0] = lastfourchars[1];
                    lastfourchars[1] = lastfourchars[2];
                    lastfourchars[2] = lastfourchars[3];
                    lastfourchars[3] = buffer[pos];

                    if( !strcmp(lastfourchars, "\r\n\r\n") )
                    {
                        textfound = 1;
                        break;
                    }
                }

                if(!textfound)
                    numbytes = recv(httpsock, buffer, MAXDATASIZE, 0);

                if(numbytes <= 0)
                {
                    if(httpsock > 0)
                        close(httpsock);
                    return SLRC_GenericError; // error
                }
            }

            // parse the html server list.
            if(textfound)
            {
                int offset = 0;

                while(numbytes > 0)
                {
                    for(; pos < numbytes; pos++)
                    {
                        if(offset < MAX_SERVERSTRING)
                            ServerList[offset] = buffer[pos];
                        offset++;
                    }

                    pos = 0;
                    numbytes = recv(httpsock, buffer, MAXDATASIZE, 0);
                }

                ServerList[offset] = 0;

                ParseServerList();

                if(httpsock > 0)
                    close(httpsock);

                return SLRC_ReceivedList;
            }
        }

        if(httpsock > 0)
            close(httpsock);
        return errorcode;
    }

    if(httpsock > 0)
        close(httpsock);
    return SLRC_GenericError; // error
}

#define GameName        "ExGasOS"
#define Version         "0.2"
#define HTTPInfo        "HTTP/1.0\r\nHost: www.atouchofwar.com\r\nUser-Agent: AToWGameBrowser/1.0 (NDS)\r\n\r\n"

int SERVERLIST_GetList()
{
    int ret = SERVERLIST_SetupSocket();

    if(ret != -1)
    {
        SERVERLIST_ClearList();
        sprintf(serverstr, "GET /GameServersV2.php?Game=%s&Version=%s %s",
                    GameName, Version, HTTPInfo);
        send(httpsock, serverstr, (int)strlen(serverstr), 0);
        return 0; // no error
    }

    return 1; // error
}

int SERVERLIST_AddServer()
{
    int ret = SERVERLIST_SetupSocket();

    if(ret != -1)
    {
        char SessionName[20];
        int c = 0;
        int i;
        for(i=0; i<PersonalData->nameLen; i++)
        {
            if((PersonalData->name[i] >= 'a' && PersonalData->name[i] <= 'z') ||
               (PersonalData->name[i] >= 'A' && PersonalData->name[i] <= 'Z') ||
               (PersonalData->name[i] >= '0' && PersonalData->name[i] <= '9') )
            {
                SessionName[c] = PersonalData->name[i];
                c++;
            }
        }
        SessionName[c] = 0;
        unsigned long serverip = Wifi_GetIP();

        SERVERLIST_ClearList();
        sprintf(serverstr, "GET /GameServersV2.php?Game=%s&Version=%s&LANIP=%d.%d.%d.%d&SessionName=%s&Add %s",
                    GameName, Version,
                    (int)serverip&0xFF, ((int)serverip>>8)&0xFF, ((int)serverip>>16)&0xFF, ((int)serverip>>24)&0xFF,
                    SessionName, HTTPInfo);
        send(httpsock, serverstr, (int)strlen(serverstr), 0);
        return 0; // no error
    }

    return 1; // error
}

int SERVERLIST_RemoveServer()
{
    int ret = SERVERLIST_SetupSocket();

    if(ret != -1)
    {
        SERVERLIST_ClearList();
        sprintf(serverstr, "GET /GameServersV2.php?Game=%s&Version=%s&Remove %s",
                    GameName, Version, HTTPInfo);
        send(httpsock, serverstr, (int)strlen(serverstr), 0);
        return 0; // no error
    }

    return 1; // error
}

int SERVERLIST_UpdateServer(int joinable, int numplayers)
{
    int ret = SERVERLIST_SetupSocket();

    if(ret != -1)
    {
        SERVERLIST_ClearList();
        if(joinable == 1)
        {
            sprintf(serverstr, "GET /GameServersV2.php?Game=%s&Version=%s&NumPlayers=%d&Joinable&Update %s",
                        GameName, Version, numplayers, HTTPInfo);
            send(httpsock, serverstr, (int)strlen(serverstr), 0);
        }
        else
        {
            sprintf(serverstr, "GET /GameServersV2.php?Game=%s&Version=%s&NumPlayers=%d&Full&Update %s",
                        GameName, Version, numplayers, HTTPInfo);
            send(httpsock, serverstr, (int)strlen(serverstr), 0);
        }
        return 0; // no error
    }

    return 1; // error
}

int SERVERLIST_SetupSocket()
{
    if(httpsock > 0)
        close(httpsock);
    httpsock = 0;

    sockaddr_in server;

    ServerList[0] = 0;
    httpsock = socket(AF_INET, SOCK_STREAM, 0);
    if(httpsock == -1)
        return -1;

    memset(&server, 0, sizeof(sockaddr_in));
    server.sin_family = AF_INET;
    server.sin_port = htons(PORT);
    server.sin_addr = *((in_addr*)hostinfo->h_addr_list[0]);

    int i=1;
    ioctl(httpsock, FIONBIO, &i); // set non-blocking

    int ret = connect(httpsock, (sockaddr*)&server, sizeof(sockaddr));

    //int ret = connect(httpsock, (sockaddr*)&server, sizeof(sockaddr));

    return ret;
}

void SERVERLIST_CancelOp()
{
    close(httpsock);
}

void SERVERLIST_ClearList()
{
    ServerList[0] = 0;
    SERVERLIST_NumServers = 0;
}
