#include "MySystem.h"

#include <stdlib.h>
#include <malloc.h>

#include "touch.h"
#include "string.h"
#include "TextMap.h"

#if SYSTEM_NDS
#include "FIFO.h"
#endif //SYSTEM_NDS

#include "WifiMenu.h"
#include "ServerList.h"
#include "Menu.h"

#include "NetMessages.h"
#include "NetCode.h"

#include "GameLobby.h"

SOCKET BroadcastSock = 0;
int LastBroadcastTime = 0;
sockaddr_in BroadcastAddr;

void LAN_SetupBroadcastPort()
{
    BroadcastSock = socket(AF_INET, SOCK_DGRAM, 0);

    int i=1;
    ioctl(BroadcastSock, FIONBIO, &i);

    memset( &BroadcastAddr, 0, sizeof(sockaddr_in) );
    BroadcastAddr.sin_family = AF_INET;
    BroadcastAddr.sin_addr.s_addr = 0xffffffff;
    BroadcastAddr.sin_port = htons(9999);

}

void LAN_BroadcastRequestForServers()
{
    if(g_FrameCount - LastBroadcastTime > 30)
    {
        LastBroadcastTime = g_FrameCount;
        int ret = sendto(BroadcastSock, "blah", sizeof("blah"), 0, (sockaddr*)&BroadcastAddr, sizeof(sockaddr_in));

        if(ret == -1)
        {
        }
    }
}

void LAN_CloseBroadcastPort()
{
    close(BroadcastSock);
}

unsigned long StringToIP(char* str)
{
    int num;
    unsigned long ip = 0;
    int chunk = 0;
    unsigned int i;

    int finddot = 0;
    while(chunk < 4)
    {
        for(i=0; i<strlen(str); i++)
        {
            if(str[i] == '.')
            {
                i++;
                finddot = 0;
            }

            if(finddot == 0)
            {
                num = atoi(&str[i]) << (chunk*8);
                ip += num;
                chunk++;
                finddot = 1;
            }
        }
    }

    return ip;
}

void IPToString(unsigned long ip, char* str)
{
    //char temp[4];
    //str[0] = 0;
    //itoa(ip&0xFF, temp, 10);
    //strcat(str, temp);
    //ip>>8;
    //strcat(str, ".");
    //itoa(ip&0xFF, temp, 10);
    //strcat(str, temp);
    //ip>>8;
    //strcat(str, ".");
    //itoa(ip&0xFF, temp, 10);
    //strcat(str, temp);
    //ip>>8;
    //strcat(str, ".");
    //itoa(ip&0xFF, temp, 10);
    //strcat(str, temp);
}

int Menu_ServerSelect(int lan)
{
    int timeposted = g_FrameCount;
    int i;

    int currentselected = 0;
    int WaitingForList = 0;

    if(lan)
        LAN_SetupBroadcastPort();

    while(1)
    {
        SERVERLIST_GetList();
        //if(lan == 0)
            WaitingForList = 1;

        while(WaitingForList)
        {
            scanKeys();
#if SYSTEM_NDS
            swiWaitForVBlank();
#endif //SYSTEM_NDS

            // clear the screen
            ClearTextMap(NULL);

            DrawTextToMap(1, NULL, 5, 4, TextColor, "Getting Server List");
            DrawTextToMap(1, NULL, 5, 6, TextColor, "Press 'B' to cancel");

            if(g_FrameCount > timeposted + 120)
            {
                timeposted = g_FrameCount;
                SERVERLIST_GetList();
            }

            int SL_Returncode = SERVERLIST_CheckForResults();

            if(SL_Returncode != SLRC_Waiting)
            {
                WaitingForList = 0;
            }

            if( keysUp() & KEY_B )
            {
                SERVERLIST_CancelOp();
                return 1; // error
            }
        }

        while(1)
        {
            if(lan)
            {
                LAN_BroadcastRequestForServers();
            }

            scanKeys();
            swiWaitForVBlank();

            ClearTextMap(NULL);

            DrawTextToMap(1, NULL, 9, 4, TextColor, "Server List");
            DrawTextToMap(1, NULL, 5, 6, TextColor, "Press 'X' to refresh");

            if(SERVERLIST_NumServers == 0)
            {
                DrawTextToMap(1, NULL, 6, 10, TextColor, "No Servers Found");
            }
            else
            {
                DrawTextToMap(1, NULL, 5, 8, TextColor, "Press 'A' to join game");

                for(i=0; i<SERVERLIST_NumServers; i++)
                {
                    if(lan)
                        sprintf(temptext, "%s", SERVERLIST_Names[i]);//, SERVERLIST_LANIPs[i]);
                    else
                        sprintf(temptext, "%s", SERVERLIST_Names[i]);//, SERVERLIST_Servers[i]);
                    DrawTextToMap(1, NULL, 6, 10+i, TextColor, temptext);
                }

                if( keysUp() & KEY_UP )
                    currentselected--;
                if( keysUp() & KEY_DOWN )
                    currentselected++;

                if(currentselected < 0)
                    currentselected = 0;
                if(currentselected > SERVERLIST_NumServers-1)
                    currentselected = SERVERLIST_NumServers-1;

                if(SERVERLIST_NumServers)
                    DrawTextToMap(1, NULL, 3, 10+currentselected, TextColor, "->");

                if( keysUp() & KEY_A )
                {
                    if(lan)
                        serverip = StringToIP(SERVERLIST_LANIPs[currentselected]);
                    else
                        serverip = StringToIP(SERVERLIST_Servers[currentselected]);
                    
                    if(lan)
                        LAN_CloseBroadcastPort();
                    return 0;
                }
            }

            if( keysUp() & KEY_B )
            {
                if(lan)
                    LAN_CloseBroadcastPort();
                else
                    SERVERLIST_CancelOp();
                return 1; // error
            }

            if( keysUp() & KEY_X )
            {
                break;
            }
        }
    }

    if(lan)
        LAN_CloseBroadcastPort();

    return 1; // error
}
