#include "MySystem.h"
#include "MyDMA.h"

void DMA_16bitCopy(uint8 channel, uint32* src, uint32* dest, uint32 size)
{
#if SYSTEM_NDS
	DMA_SRC(channel) = (uint32)src;
	DMA_DEST(channel) = (uint32)dest;
	DMA_CR(channel) = DMA_COPY_HALFWORDS | size;
	while(DMA_CR(channel) & DMA_BUSY);
#endif //SYSTEM_NDS
}

void DMA_32bitCopy(uint8 channel, uint32* src, uint32* dest, uint32 size)
{
#if SYSTEM_NDS
	DMA_SRC(channel) = (uint32)src;
	DMA_DEST(channel) = (uint32)dest;
	DMA_CR(channel) = DMA_COPY_WORDS | size;
	while(DMA_CR(channel) & DMA_BUSY);
#endif //SYSTEM_NDS
}

void DMA_Wait(uint8 channel)
{
#if SYSTEM_NDS
	while(DMA_CR(channel) & DMA_BUSY);
#endif //SYSTEM_NDS
}

