#include "MySystem.h"
#include <assert.h>

#define MEMORY_ShowDebugInfo   0

CPPListHead AllocatedRam;
int TotalAllocatedRam = 0;

void ValidateAllocations()
{
    //CPPListNode* node;
    //for( node = AllocatedRam.HeadNode.Next; node->Next; node = node->Next )
    //{
    //    MemObject* obj = (MemObject*)node;
    //    assert( obj->m_size < 100000 );
    //    assert( obj->m_type < 3 );
    //    assert( obj->m_line < 2500 );
    //    assert( obj->Next != NULL );
    //    assert( obj->Prev != NULL );
    //}
}

void operator delete(void* m, char* file, unsigned long line)
{
    delete((char*)m);
}

void operator delete[](void* m, char* file, unsigned long line)
{
    delete((char*)m);
}

void* operator new(size_t size, char* file, unsigned long line)
{
    MemObject* mo = (MemObject*)malloc( size + sizeof(MemObject) );

    mo->m_size = size;
    mo->m_type = newtype_reg;
    mo->m_file = file;
    mo->m_line = line;
    AllocatedRam.AddHead(mo);

#if MEMORY_ShowDebugInfo
    sprintf(DEBUG_String, "ALLOC: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)(((char*)mo) + sizeof(MemObject)));
    DEBUG_Print();
#endif

    TotalAllocatedRam += (int)size;
    return ((char*)mo) + sizeof(MemObject); //mo + sizeof(MemObject);
}

void* operator new[](size_t size, char* file, unsigned long line)
{
    MemObject* mo = (MemObject*)malloc( size + sizeof(MemObject) );

    mo->m_size = size;
    mo->m_type = newtype_array;
    mo->m_file = file;
    mo->m_line = line;
    AllocatedRam.AddHead(mo);

#if MEMORY_ShowDebugInfo
    sprintf(DEBUG_String, "ALLOC ARRAY: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)(((char*)mo) + sizeof(MemObject)));
    DEBUG_Print();
#endif

    TotalAllocatedRam += (int)size;
    return ((char*)mo) + sizeof(MemObject); //mo + sizeof(MemObject);
}
//
//void* operator new(size_t size)
//{
//    MemObject* mo = (MemObject*)malloc( size + sizeof(MemObject) );
//    mo->m_size = size;
//    mo->m_type = newtype_reg;
//    AllocatedRam.AddHead(mo);
//
//#if MEMORY_ShowDebugInfo
//    sprintf(DEBUG_String, "ALLOC: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)(((char*)mo) + sizeof(MemObject)));
//    DEBUG_Print();
//#endif
//
//    TotalAllocatedRam += (int)size;
//    return ((char*)mo) + sizeof(MemObject); //mo + sizeof(MemObject);
//}

void operator delete(void* m)
{
    MemObject* mo = (MemObject*)(((char*)m) - sizeof(MemObject));
    size_t size = mo->m_size;
    if(mo->m_type == newtype_reg)
        mo->Remove();

#if MEMORY_ShowDebugInfo
    sprintf(DEBUG_String, "FREE: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)m);
    DEBUG_Print();
#endif

    TotalAllocatedRam -= (int)size;
    free(mo);
}
//
//void* operator new[](size_t size)
//{
//    MemObject* mo = (MemObject*)malloc( size + sizeof(MemObject) );
//    mo->m_size = size;
//    mo->m_type = newtype_array;
//    AllocatedRam.AddHead(mo);
//
//#if MEMORY_ShowDebugInfo
//    sprintf(DEBUG_String, "ALLOC ARRAY: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)(((char*)mo) + sizeof(MemObject)));
//    DEBUG_Print();
//#endif
//
//    TotalAllocatedRam += (int)size;
//    return ((char*)mo) + sizeof(MemObject); //mo + sizeof(MemObject);
//}

void operator delete[](void* m)
{
    MemObject* mo = (MemObject*)(((char*)m) - sizeof(MemObject));
    size_t size = mo->m_size;
    if(mo->m_type == newtype_array)
        mo->Remove();

#if MEMORY_ShowDebugInfo
    sprintf(DEBUG_String, "FREE ARRAY: %d, %08x, %08x", (int)mo->m_size, (unsigned int)mo, (unsigned int)m);
    DEBUG_Print();
#endif

    TotalAllocatedRam -= (int)size;
    free(mo);
}
