#ifndef __MYSYSTEM_H__
#define __MYSYSTEM_H__

#define SYSTEM_NDS  1
#define SOCKET  int

#include <stdlib.h>
#include <string.h>

#include <NDS/jtypes.h>
#include <NDS/system.h>
#include <NDS/memory.h>
#include <NDS/ARM9/input.h>
#include <NDS/ipc.h>
#include <NDS/bios.h>
#include <NDS/ARM9/sound.h>		// sound functions
#include <NDS/ARM9/Video.h>
#include <NDS/interrupts.h>
#include <NDS/dma.h>

#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
//#include "ENet.h"
#include "FIFO.h"

#include <stdio.h>
#include <math.h>

#include "MyDMA.h"



#include "TileInfo.h"

#include "CPPList.h"
#include "BaseObject.h"
#include "BombMain.h"

#include "NetMessages.h"
#include "PacketStack.h"
#include "NetCode.h"

//#include "MyRand.h"
#include "MyMemory.h"

#include "DebugStr.h"
#include "helpers.h"
#include "mt.h"

#include "SRAMSave.h"

#include "BaseObject.h"

#include "Menu.h"

#include "PlayerObject.h"
#include "BlockObject.h"
#include "BombObject.h"
#include "BreakableBlockObject.h"
#include "FlameObject.h"
#include "ElevatorObject.h"
#include "PowerUpObject.h"
#include "ObjectManager.h"

#include "GameSounds.h"

#include "GameBoard.h"

int SYS_Init(void);

#define null        0

#define SAFE_DELETE(x) { if(x) { delete (x); (x) = NULL; } }
#define SAFE_DELETE_ARRAY(x) { if(x) { delete[] (x); (x) = NULL; } }
#define SAFE_REDUCEREFANDDELETE(x) { if(x) { (x)->refcount--; if((x)->refcount == 0) delete (x); (x) = NULL; } }

extern int g_CountOfSomething;

#endif //__MYSYSTEM_H__
