#ifndef __PACKETSTACK_H__
#define __PACKETSTACK_H__

#define MAX_MESSAGE_SIZE            1000

#define MAX_PACKETSENT_BACKLOG      100
#define MAX_PACKETRECEIVED_BACKLOG  100

struct MessageInfo
{
    NetMessage* message;
    int id;
    int size;

    int framesent;
};

class PacketStack
{
private:
    MessageAck m_MessageAck;
    int m_MessageAckSize;

    int m_ConnectionNumber;
    SOCKET m_DestSocket;
    sockaddr m_DestSain;

    MessageInfo m_MessagesAwaitingAck[MAX_PACKETSENT_BACKLOG];
    //int m_FrameSent[MAX_PACKETSENT_BACKLOG];
    int m_NumMessagesAwaitingAck;
    u16 m_NextMessageNumber;

    NetMessage* m_MessagesOutOfOrder[MAX_PACKETRECEIVED_BACKLOG];
    int m_MessagesOutOfOrderID[MAX_PACKETRECEIVED_BACKLOG];
    int m_NumMessagesOutOfOrder;
    u16 m_NextMessageNeeded;

    void RemoveMessageFromStack(int id, int deletemessage);
    void CheckForOldMessagesToResend();

    int IsMessageInOutOfOrderQueue(int id);
    void CheckForOutOfOrderMessages();

public:
    PacketStack();
    ~PacketStack();

    void Cleanup();

    int SendTo(int reliable, SOCKET socket, NetMessage* message, int size, int flags, sockaddr* addr, int addrsize);
    void Tick(SOCKET socket);
    void ProcessMessage(SOCKET socket, char* message, int size, int connindex);

    void SetConnectionInfo(int conn, SOCKET socket, sockaddr_in* addr);
};

#endif //__PACKETSTACK_H__
