#include "MySystem.h"

int AllowSRAMSave = 0;

SRAMSave::SRAMSave() :
    m_SaveEnabled(false),
    m_Offset(0),
    m_BufferOffset(0)
{
}

SRAMSave::~SRAMSave()
{
}

void SRAMSave::Init()
{
    m_SaveEnabled = 0;

    if(AllowSRAMSave == 0)
        return;

#if SYSTEM_NDS
    // set the sram area to be read/written by the arm9
    WAIT_CR &= ~0x0880;
    char card_id[5] = { 0,0,0,0,0 };
    memcpy(card_id, (char*)0x080000AC, 4);
    if(card_id[0] == 'P' &&
       card_id[1] == 'A' &&
       card_id[2] == 'S' &&
       card_id[3] == 'S' )
        m_SaveEnabled = 1;
#endif

    m_Offset = 0;
    m_BufferOffset = 0;
}

void SRAMSave::Write(char* data, int len)
{
    if( !SavingAllowed() )
        return;

    if(m_Offset+len > 65000)
        m_BufferOffset = 0;
        //return;

    memcpy(&m_Buffer[m_BufferOffset], data, len);
    m_BufferOffset += len;

    //if(m_BufferOffset > 50)
    {
        Flush();
    }
}

void SRAMSave::Flush()
{
    if( !SavingAllowed() )
        return;

    int len = m_BufferOffset;

    if(m_Offset + len >= 65535)
        return;

#if SYSTEM_NDS
    int i;
    for(i=0; i<len; i++)
        SRAM[m_Offset + i] = m_Buffer[i];
#endif

    //memcpy(&SRAM[m_Offset], m_Buffer, len);

    //if(_RELEASE == 0)
    //{
    //    if( memcmp(&SRAM[m_Offset], m_Buffer, len) )
    //    {
    //        sprintf(temptext, "save failed, %d", len);
    //        PrintToScreen(temptext);
    //    }
    //}

    m_BufferOffset = 0;
    m_Offset += len;
}
