#include "MySystem.h"
#include <string.h>
#include "TextMap.h"
#include "BombGraphics.h"

#include "../art/Font.pal"
#include "../art/Font.til"

void ClearTextMap(u16* map)
{
    int x,y;
    u16* HWMap;

    HWMap = (uint16*)SCREEN_BASE_BLOCK(FONT_SCREEN_BASE_BLOCK);
    if(map != NULL)
        HWMap = map;

    for(y=0; y<24; y++)
        for(x=0; x<32; x++)
            HWMap[y*32+x] = FONT_TILE_BLANK;

    HWMap = (uint16*)SCREEN_BASE_BLOCK_SUB(FONT_SCREEN_BASE_BLOCK);
    if(map != NULL)
        HWMap = map;

    for(y=0; y<24; y++)
        for(x=0; x<32; x++)
            HWMap[y*32+x] = FONT_TILE_BLANK;
}

void SetupSubScreenFont()
{
    //=====================================================
    // on the sub display, init some hacked font stuff. tiles FONT_TILE_OFFSET-xxx
    //=====================================================
    //fill tile FONT_TILE_BLANK with all black
#if SYSTEM_NDS
    int i;

    for(i=0; i<16; i++)
        BG_GFX[FONT_TILE_BLANK*16+i] = 0x0000;

    //LoadPalette(BG_PALETTE, 32, (u16*)FontPalette, 16);
    DMA_32bitCopy(3, (uint32*)FontTiles, (uint32*)BG_GFX+FONT_TILE_OFFSET*8, sizeof(FontTiles));
    BG0_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (FONT_SCREEN_BASE_BLOCK << SCREEN_SHIFT);

    for(i=0; i<16; i++)
        BG_GFX_SUB[FONT_TILE_BLANK*16+i] = 0x0000;

    //LoadPalette(BG_PALETTE_SUB, 32, (u16*)FontPalette, 16);
    DMA_32bitCopy(3, (uint32*)FontTiles, (uint32*)BG_GFX_SUB+FONT_TILE_OFFSET*8, sizeof(FontTiles));
    SUB_BG0_CR = TEXTBG_SIZE_256x256 | BG_COLOR_16 | BG_PRIORITY_0 | (FONT_SCREEN_BASE_BLOCK << SCREEN_SHIFT);
#endif //SYSTEM_NDS
}

// 0-9 A-Z;
void DrawTextToMap(int screen, u16* map, u8 x, u8 y, int palette, char* text, ...)
{
    u16* HWMap;
    
    if(screen == 0)
        HWMap = (uint16*)SCREEN_BASE_BLOCK(FONT_SCREEN_BASE_BLOCK);
    else
        HWMap = (uint16*)SCREEN_BASE_BLOCK_SUB(FONT_SCREEN_BASE_BLOCK);

    if(map != NULL)
        HWMap = map;

    int tileoffset = FONT_TILE_OFFSET;

    u16 i;

    for(i=0; i<strlen(text); i++)
    {
        unsigned char letter = text[i];

        //if(letter >= 'a' && letter <= 'z')
        //    letter = letter - 'a' + 'A';

        if(letter >= ' ' && letter <= 'z')
            letter = letter - ' ';

        int offset = y*32+x+i;
        if(offset > 24*32 + 32)
            return;

        HWMap[offset] = palette<<12 | tileoffset + letter;
    }
}

