#include "MySystem.h"

#define TOUCH_MOVETHRESHOLD     5

int GetTouchXY(int framecount, int* outx, int* outy)
{
    int x,y;
    static int TouchSettled = 0;

    static int lx, ly;
    static int llx, lly;
    static int framesettled;

    if(keysDown() & KEY_TOUCH)
    {
        TouchSettled = 0;
        lx = -100;
        ly = -100;
        llx = -100;
        lly = -100;
    }

    if(keysUp() & KEY_TOUCH)
    {
        TouchSettled = 0;
        lx = -100;
        ly = -100;
        llx = -100;
        lly = -100;
    }

    if(keysHeld() & KEY_TOUCH)
    {
        touchPosition tpos = touchReadXY();

        x = tpos.px;
        y = tpos.py;

        // once the pen down has settled, lag two frames behind to help avoid a bad read on pen up.
        if(TouchSettled > 0)            
        {
            TouchSettled++; // count frames touch has been on.

            if(framecount-framesettled > 2)
            {
                if(llx != -100 && lly != -100)
                {
                    *outx = llx;
                    *outy = lly;
                }
            }
            else
            {
                *outx = lx;
                *outy = ly;
            }
        }
        else //if(!TouchSettled)
        {
            if(abs(lx - x) < TOUCH_MOVETHRESHOLD && abs(ly - y) < TOUCH_MOVETHRESHOLD)
            {
                *outx = x;
                *outy = y;
                TouchSettled = 1;
                framesettled = framecount;
            }
        }

        lx = x;
        ly = y;
        llx = lx;
        lly = ly;
    }

    return TouchSettled;
}

//#define TOUCH_CAL_X1 (*(vs16*)0x027FFCD8)
//#define TOUCH_CAL_Y1 (*(vs16*)0x027FFCDA)
//#define TOUCH_CAL_X2 (*(vs16*)0x027FFCDE)
//#define TOUCH_CAL_Y2 (*(vs16*)0x027FFCE0)
//#define SCREEN_WIDTH    256
//#define SCREEN_HEIGHT   192
//s32 TOUCH_WIDTH  = TOUCH_CAL_X2 - TOUCH_CAL_X1;
//s32 TOUCH_HEIGHT = TOUCH_CAL_Y2 - TOUCH_CAL_Y1;
//s32 TOUCH_OFFSET_X = ( ((SCREEN_WIDTH -60) * TOUCH_CAL_X1) / TOUCH_WIDTH  ) - 28;
//s32 TOUCH_OFFSET_Y = ( ((SCREEN_HEIGHT-60) * TOUCH_CAL_Y1) / TOUCH_HEIGHT ) - 28;
//
////3392 708 = 2684 = 79.12
////3336 864 = 2472 = 74.1
//int QueryXpx()
//{
//    int x,y,xpx,ypx;
//
//    if(!(IPC->buttons & 0x40))
//    {
//        x = IPC->touchX;
//        y = IPC->touchY;
//        xpx = ( ((SCREEN_WIDTH -60) * x) / TOUCH_WIDTH  ) - TOUCH_OFFSET_X;
//        ypx = ( ((SCREEN_HEIGHT-60) * y) / TOUCH_HEIGHT ) - TOUCH_OFFSET_Y;
//
//        // x = 3392
//        // tox = (256-60) * 708 / 2684 - 28 = 51.7
//        //xpx = ( ((256-60) * 3392) / 2684  ) - TOUCH_OFFSET_X;
//        //xpx = ( 247.7  ) - 51.7; = 196
//
//        if(xpx < 0) xpx = 0;
//
//        return xpx;
//    }
//
//    return -1;
//};
//
//int QueryYpx()
//{
//    int x,y,xpx,ypx;
//
//    if(!(IPC->buttons & 0x40))
//    {
//        x = IPC->touchX;
//        y = IPC->touchY;
//        xpx = ( ((SCREEN_WIDTH -60) * x) / TOUCH_WIDTH  ) - TOUCH_OFFSET_X;
//        ypx = ( ((SCREEN_HEIGHT-60) * y) / TOUCH_HEIGHT ) - TOUCH_OFFSET_Y;
//    
//        if(ypx < 0) ypx = 0;
//
//        return ypx;
//    }
//
//    return -1;
//};
